
const OPER03010_GRID_ID = '#ITP_OPER03010_jqGrid';
const OPER03010_GRID_LIST = '#ITP_OPER03010_jqGrid_list';
const OPER03010_GRID_PAGER = '#ITP_OPER03010_jqGridPager';
const OPER03010_GRID_EMPTY = '#ITP_OPER03010_jqGridEmpty';

const OPER03010_VIEW_GRID_ID = '#ITP_OPER03010_VIEW_jqGrid';
const OPER03010_VIEW_GRID_LIST = '#ITP_OPER03010_VIEW_jqGrid_list';
const OPER03010_VIEW_GRID_PAGER = '#ITP_OPER03010_VIEW_jqGridPager';
const OPER03010_VIEW_GRID_EMPTY = '#ITP_OPER03010_VIEW_jqGridEmpty';

const OPER03010_DETAIL_GRID_ID = '#ITP_OPER03010_DETAIL_jqGrid';
const OPER03010_DETAIL_GRID_LIST = '#ITP_OPER03010_DETAIL_jqGrid_list';
const OPER03010_DETAIL_GRID_PAGER = '#ITP_OPER03010_DETAIL_jqGridPager';
const OPER03010_DETAIL_GRID_EMPTY = '#ITP_OPER03010_DETAIL_jqGridEmpty';

let ITP_FORM_OPER03010_DETAIL_IS_DUPLICATE = false;
let ITP_FORM_OPER03010_DETAIL_IS_WRITING = false;

let AFFL_DETAIL_GRID_LIST = '/api/affl/detail-grid-list';
let AFFL_INFO_AFFL = '/api/affl/info-affl';
let COMPANY_INFO_COMPANY = '/api/affl/info-frcomp';
let COMPANY_SAVE_COMPANY = '/api/affl/save-frcomp';
let COMPANY_CHECK_DUPLICATE = '/api/affl/check-duplicate';
let USER_INTI_USERPW = '/api/user/inti-userpw';

let kakaoMap = {
    init: function(id, locate) {
        this.load(id, locate);
    },
    geocoder: null,
    schDetailAddrFromCoords: function(coords, callback) {
        // 좌표로 법정동 상세 주소 정보를 요청합니다
        if(this.geocoder) {
            this.geocoder.coord2Address(coords.getLng(), coords.getLat(), callback);
        }
    },
    getMap: function(id) {
        var mapContainer = document.getElementById(id), // 지도를 표시할 div
            mapOption = {
                center: new kakao.maps.LatLng(37.56684, 126.97865), // 지도의 중심좌표
                level: 3, // 지도의 확대 레벨
                mapTypeId : kakao.maps.MapTypeId.ROADMAP // 지도종류
            };

        // 지도를 생성한다
        var map = new kakao.maps.Map(mapContainer, mapOption);

        // 마우스 휠과 모바일 터치를 이용한 지도 확대, 축소를 막는다
        map.setZoomable(false);

        // 지도에 확대 축소 컨트롤을 생성한다
        //var zoomControl = new kakao.maps.ZoomControl();

        // 지도의 우측에 확대 축소 컨트롤을 추가한다
        //map.addControl(zoomControl, kakao.maps.ControlPosition.RIGHT);

        return map;
    },
    marker: function(map, coords) {
        // 지도에 마커를 생성하고 표시한다
        marker = new kakao.maps.Marker({
            position: coords, // 마커의 좌표
            map: map // 마커를 표시할 지도 객체
        });
    },
    load: function(id, locate) {
        var _this = this;
        kakao.maps.load(function() {
            var map = _this.getMap(id);
            // 주소-좌표 변환 객체를 생성합니다
            _this.geocoder = new kakao.maps.services.Geocoder();
            if( !locate || locate.length == 0 ) {
                // 지도에 마커를 생성하고 표시한다
                _this.marker(map, new kakao.maps.LatLng(37.56684, 126.97865));
            } else {
                // 주소로 좌표를 검색합니다
                _this.geocoder.addressSearch(locate, function(result, status) {
                    // 정상적으로 검색이 완료됐으면
                    if (status === kakao.maps.services.Status.OK) {

                        var coords = new kakao.maps.LatLng(result[0].y, result[0].x);
                        if(id === 'ITP_FORM_OPER04010_DETAIL_MAP') {
                            document.getElementById('ITP_FORM_OPER04010_DETAIL_LAT').value = result[0].y;
                            document.getElementById('ITP_FORM_OPER04010_DETAIL_LNG').value = result[0].x;
                        }

                        // 결과값으로 받은 위치를 마커로 표시합니다
                        _this.marker(map, coords);

                        // 지도의 중심을 결과값으로 받은 위치로 이동시킵니다
                        map.setCenter(coords);
                    } else {
                        _this.marker(map, new kakao.maps.LatLng(37.56684, 126.97865));
                    }
                });
            }

            if(id === 'ITP_FORM_OPER04010_DETAIL_MAP') {
                _this.listener.drag(map);
            }
        });
    },
    listener: {
        drag: function(map) {
            var _this = this;
            // 지도 드래깅 이벤트를 등록한다 (드래그 시작 : dragstart, 드래그 종료 : dragend)
            kakao.maps.event.addListener(map, 'drag', function () {
                kakaoMap.schDetailAddrFromCoords(map.getCenter(), function(result, status) {
                    if (status === kakao.maps.services.Status.OK) {

                        document.getElementById('ITP_FORM_OPER04010_DETAIL_LOTS_ADDRESS').value = result[0].address.address_name ;
                        document.getElementById('ITP_FORM_OPER04010_DETAIL_ADRES').value = !!result[0].road_address ? result[0].road_address.address_name : result[0].address.address_name ;
                        document.getElementById('ITP_FORM_OPER04010_DETAIL_STREET_ADDRESS').value = !!result[0].road_address ? result[0].road_address.address_name : $('#ITP_FORM_OPER04010_DETAIL_STREET_ADDRESS').val();
                        document.getElementById('ITP_FORM_OPER04010_DETAIL_ZIPNO').value = !!result[0].road_address ? result[0].road_address.zone_no : $('#ITP_FORM_OPER04010_DETAIL_CMPY_ZIPNO').val() ;
                        document.getElementById('ITP_FORM_OPER04010_DETAIL_LAT').value = map.getCenter().getLat();
                        document.getElementById('ITP_FORM_OPER04010_DETAIL_LNG').value = map.getCenter().getLng();

                        // 마커를 클릭한 위치에 표시합니다
                        marker.setPosition(map.getCenter());
                        marker.setMap(map);
                    }
                });
                /* 	var message = '지도를 드래그 하고 있습니다. 지도의 중심 좌표는 ' + map.getCenter().toString() +' 입니다.';
                console.log(message); */
            });
        }
    }
};

const gridColModel = {
	// 목록
	list: [
		{
			index: 'AFFL_SHOP_ID', name: 'afflShopId',
			label: '가맹점코드',
			width: '6', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'AFFL_SHOP_NM', name: 'afflShopNm',
			label: '가맹점명',
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'CORP_TYPE_NM', name: 'corpTypeNm',
			label: '기업형태',
			width: '6', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'ST_NM', name: 'stNm',
			label: '기업상태',
			width: '6', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'OWNER_NM', name: 'ownerNm',
			label: '대표자명',
			width: '6', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'OWNER_TEL', name: 'ownerTel',
			label: '대표연락처',
			width: '6', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'JOIN_DT', name: 'joinDt',
			label: '가입일자',
			width: '8', fixed: false, align: 'center',
			sortable: false, hidden: false
		}
	],
	detail: [
		// {
		// 	index: 'VIEW_CD', name: 'viewCd',
		// 	label: ITP_MSG_LOCALE.label.viewCd,
		// 	width: '10', fixed: false, align: 'center',
		// 	sortable: false, hidden: true
		// },
		{
			index: 'SALE_MGR_ID', name: 'saleMgrId',
			label: '영업담당자ID',
			width: '20', fixed: false, align: 'center',
			sortable: false, editable: false, edittype: 'text',
			editrules: {required: true}
		},
		{
			index: 'SALE_MGR_NM', name: 'saleMgrNm',
			label: '영업담당자명',
			width: '30', fixed: false, align: 'center',
			sortable: true, editable: false, edittype: 'text',
			editrules: {required: true}
		},
		{
			index: 'ST_CD', name: 'stCd',
			label: ITP_MSG_LOCALE.label.status,
			width: '10', fixed: false, align: 'center',
			sortable: false, editable: false, edittype: 'text', hidden: true
		},
		{
			index: 'ST_NM', name: 'stNm',
			label: ITP_MSG_LOCALE.label.status,
			width: '10', fixed: false, align: 'center',
			sortable: false, editable: false, edittype: 'text'
		},
		{
			index: 'AFFL_SHOP_ID', name: 'afflShopId',
			label: '가맹점코드',
			width: '10', fixed: false, align: 'center',
			sortable: false, editable: false, edittype: 'text', hidden: true
		}
	]
};

require(['config'], function() {
	require([
		'kakao.postcode',
		'kakao.maps'
	], function($) {
		pageObj.init();
	});
});

/********************************************************
 --------------------------------------------------------
 - Object 목록								            -
 --------------------------------------------------------
 * let pageObj = {}			: 화면공통 Object			*
 * let listObj = {}			: 목록화면 Object			*
 * let viewObj = {}			: 상세화면 Object			*
 * let modifyObj = {}		: 수정화면 Object			*
 * let createObj = {}		: 신규화면 Object			*
 *******************************************************/

/*화면공통 Object*/
let pageObj = {
	init: function () {
		this.ui.init();
		this.event.init();
	},
	itp_OPER03010_param: {},
	itp_OPER03010_search: false,
	ui: {
		init: function () {
			this.button();
			this.comCode();
			this.ready();
		},
		button: function () {
			// 버튼 권한설정
			fn_proc_btn_auth('OPER03010');

			// 조회일자 지정
			$('#ITP_TAB_OPER03010 .input-group.date').datepicker(ITP_DATE_LANGUAGE);
		},
		comCode: function () {
			// 공통코드 표시
			fn_make_select(CODE_LIST, 'ST_CD', 'ITP_FORM_OPER03010_SEARCH_ST_CD', true, '상태(전체)');
			fn_make_select(CODE_LIST, 'ST_CD', 'ITP_FORM_OPER03010_DETAIL_ST_CD', true, '선택');
			fn_make_select(CODE_LIST, 'CMPY_TYPE_CD', 'ITP_FORM_OPER03010_DETAIL_TYPE_CD', true, '선택');
			fn_make_select(CODE_LIST, 'AUTH_TYPE', 'ITP_FORM_OPER03010_DETAIL_AUTH_TYPE', true, '선택');
		},
		ready: function () {
			listObj.init();
		}
	},
	event: {
		init: function () {
			this.button();
		},
		button: function () {
			// 버튼 클릭 이벤트
			$('button').each(function() {
				var id = $(this).attr('id');
				$(this).on('click', function() {
					switch (id) {
						case 'ITP_BTN_OPER03010_SRH'				: listObj.button.search();		break;	// 조회 버튼 클릭
						case 'ITP_BTN_OPER03010_NEWREG'				: listObj.button.create(); 		break;	// 신규등록 버튼
						case 'ITP_BTN_OPER03010_MODIFY'				: modifyObj.button.modify();	break;	// 수정 버튼
						case 'ITP_BTN_OPER03010_CANCELLIST'			: createObj.button.cancel(); 	break;	// 취소/목록 버튼
						case 'ITP_BTN_OPER03010_DELETE'				: 								break;	// 삭제 버튼
						case 'ITP_BTN_OPER03010_SAVE'				: createObj.button.save(); 		break;	// 저장 버튼
						case 'ITP_FORM_OPER03010_DETAIL_DUP'		: createObj.button.duplicate();	break;	// 중복체크
						case 'ITP_BTN_OPER03010_RESET_PW'			: createObj.button.resetPass();	break;	// 상세:비밀번호 초기화
						case 'ITP_FORM_OPER03010_DETAIL_ADRES_SCH'	: createObj.button.address();	break;	// 신규등록 주소 찾기
						case 'ITP_BTN_OPER03010_DETAIL_ADDROW'		: createObj.button.addRow();	break;	// 신규등록 영업담당자 행 추가
						case 'ITP_BTN_OPER03010_DETAIL_DELROW'		: createObj.button.delRow();	break;	// 상세:삭제버튼
					}
				});
			});

			$('body').on('click', function(e) {
				createObj.button.resetGrid(e);
			});

		}
	},
	switchScreen: function(mode) {
		if(mode == 'LIST') { // 목록
			$('#ITP_BTN_OPER03010_MODIFY').hide();
			$('#ITP_BTN_OPER03010_CANCELLIST').hide();
			$('#ITP_BTN_OPER03010_DELETE').hide();
			$('#ITP_BTN_OPER03010_SAVE').hide();
			fn_show_btn_auth('#ITP_BTN_OPER03010_SRH');
			fn_show_btn_auth('#ITP_BTN_OPER03010_NEWREG');

			$('#ITP_AJAX_OPER03010_LIST_CONTAINER').show();
			$('#ITP_AJAX_OPER03010_DETAIL_CONTAINER').hide();
			$('#ITP_AJAX_OPER03010_VIEW_CONTAINER').hide();
		} else if(mode == 'ADD') { // 등록
			ITP_FORM_OPER03010_DETAIL_IS_DUPLICATE = true;

			$('#ITP_BTN_OPER03010_SRH').hide();
			$('#ITP_BTN_OPER03010_MODIFY').hide();
			$('#ITP_BTN_OPER03010_NEWREG').hide();
			$('#ITP_BTN_OPER03010_DELETE').hide();
			$('#ITP_BTN_OPER03010_RESET_PW').hide();
			fn_show_btn_auth('#ITP_BTN_OPER03010_CANCELLIST');
			fn_show_btn_auth('#ITP_BTN_OPER03010_SAVE');

			$('#ITP_AJAX_OPER03010_LIST_CONTAINER').hide();
			$('#ITP_AJAX_OPER03010_DETAIL_CONTAINER').show();
			$('#ITP_AJAX_OPER03010_VIEW_CONTAINER').hide();
			$('#ITP_FORM_OPER03010_DETAIL_CMPY_CD').removeAttr('readonly');
			$('#ITP_FORM_OPER03010_DETAIL_DUP').removeAttr('disabled');

			$('input[id^="ITP_FORM_OPER03010_DETAIL_"]').each(function(i) {
				($(this).attr('id') === 'ITP_FORM_OPER03010_DETAIL_VIEW_CD') ? $(this).val('C') : $(this).val('');
			});

		} else if(mode == 'MODIFY') { // 수정
			$('#ITP_BTN_OPER03010_SRH').hide();
			$('#ITP_BTN_OPER03010_MODIFY').hide();
			$('#ITP_BTN_OPER03010_NEWREG').hide();
			$('#ITP_BTN_OPER03010_DELETE').hide();
			fn_show_btn_auth('#ITP_BTN_OPER03010_RESET_PW');
			fn_show_btn_auth('#ITP_BTN_OPER03010_CANCELLIST');
			fn_show_btn_auth('#ITP_BTN_OPER03010_SAVE');

			$('#ITP_AJAX_OPER03010_LIST_CONTAINER').hide();
			$('#ITP_AJAX_OPER03010_DETAIL_CONTAINER').show();
			$('#ITP_AJAX_OPER03010_VIEW_CONTAINER').hide();
			$('#ITP_FORM_OPER03010_DETAIL_CMPY_CD').attr('readonly', true);
			$('#ITP_FORM_OPER03010_DETAIL_DUP').attr('disabled', true);
		} else if(mode == 'VIEW') { // 보기
			$('#ITP_BTN_OPER03010_SRH').hide();
			$('#ITP_BTN_OPER03010_NEWREG').hide();
			$('#ITP_BTN_OPER03010_DELETE').hide();
			$('#ITP_BTN_OPER03010_SAVE').hide();
			fn_show_btn_auth('#ITP_BTN_OPER03010_MODIFY');
			fn_show_btn_auth('#ITP_BTN_OPER03010_CANCELLIST');

			$('#ITP_AJAX_OPER03010_LIST_CONTAINER').hide();
			$('#ITP_AJAX_OPER03010_DETAIL_CONTAINER').hide();
			$('#ITP_AJAX_OPER03010_VIEW_CONTAINER').show();
		}
	}
};

/*목록화면 Object*/
let listObj = {
	init: function() {
		this.grid.init();
	},
	button: {
		search: function() {
			pageObj.itp_OPER03010_search = true;
			let param = $('#ITP_FORM_OPER03010_SEARCH').serializeObject();
			param.gridSize = $.jgrid.defaults.rowNum;
			param.gridPage = $.jgrid.defaults.page;
			$(OPER03010_GRID_ID).setGridParam({'postData': JSON.stringify(param)}).trigger('reloadGrid');
		},
		create: function() {
			pageObj.switchScreen('ADD');
			itp_fn_form_clear_validate(null, '#ITP_FORM_OPER03010_DETAIL');
			createObj.init();
		}
	},
	grid: {
		init: function() {
			// 데이터 없을때
			this.itp_fn_OPER03010_empty.push();
			itp_fn_jqgrid_resize(OPER03010_GRID_ID, OPER03010_GRID_LIST, 'lg');
			itp_fn_fire_window_resize();
			this.reload();
			this.search();
		},
		search: function() {
			pageObj.switchScreen('LIST');
			this.unload();
			this.load();
		},
		load: function() {
			var _this = this;
			let param = $('#ITP_FORM_OPER03010_SEARCH').serializeObject();
			param.gridSize = $.jgrid.defaults.rowNum;
			var option = {
				gridId: OPER03010_GRID_ID,
				colModel: gridColModel.list,
				param: JSON.stringify(param),
				url: DOMAIN + AFFL_DETAIL_GRID_LIST,
				pager: OPER03010_GRID_PAGER,
				onCellSelect: function(rowId, cellIdx, cellValue) {
					var cm = $(this).jqGrid('getGridParam', 'colModel');
					var colNm = cm[cellIdx].name;
					if (colNm == 'afflShopNm') {
						const afflCdVal = $(this).jqGrid('getCell', rowId, 'afflShopId');
						const key = {afflShopId: afflCdVal, viewCd: 'R'};
						var param = $.param(key);
						viewObj.init(param);
					}
				},
				loadComplete: function(data) {
					console.log(data);
					itp_fn_grid_load_complete(data, OPER03010_GRID_ID, true, 'number', 'OPER03010', pageObj.itp_OPER03010_search, _this.itp_fn_OPER03010_empty, true, data.gridRecords, true);
					var ids = $(OPER03010_GRID_ID).getDataIDs();
					$.each(ids, function(idx, rowId) {
						$(OPER03010_GRID_ID).jqGrid('setCell', rowId, 'afflShopNm', '', ITP_GRID_COL_STYLE.link);
					});
				}
			};
			itp_fn_grid_make_remote(option);
		},
		itp_fn_OPER03010_empty: {
			push: function() {
				let param = $('#ITP_FORM_OPER03010_SEARCH').serializeObject();
				pageObj.itp_OPER03010_param = param;
			},
			back: function() {
				$('#ITP_FORM_OPER03010_DEVI_TP_CD').val(pageObj.itp_OPER03010_param.deviTpCd);
				$('#ITP_FORM_OPER03010_ORDER_YN').val(pageObj.itp_OPER03010_param.orderYn);
				$('#ITP_FORM_OPER03010_ADT_AUTH_CD').val(pageObj.itp_OPER03010_param.adtAuthCd);
				$('#ITP_FORM_OPER03010_EMAIL_RCV_YN').val(pageObj.itp_OPER03010_param.emailRcvYn);
				$('#ITP_FORM_OPER03010_SMS_RCV_YN').val(pageObj.itp_OPER03010_param.smsRcvYn);
				$('#ITP_FORM_OPER03010_MEMB_EXIT_DT').val(pageObj.itp_OPER03010_param.membExitDt);
				$('#ITP_FORM_OPER03010_FROM_DT').val(pageObj.itp_OPER03010_param.fromDt);
				$('#ITP_FORM_OPER03010_TO_DT').val(pageObj.itp_OPER03010_param.toDt);
				$('#ITP_FORM_OPER03010_KEYWORD').val(pageObj.itp_OPER03010_param.keyword);
			}
		},
		reload : function() {
			var _this = this;
			$(OPER03010_GRID_EMPTY).off('click').on('click', function() {
				_this.itp_fn_OPER03010_empty.back();
				pageObj.itp_OPER03010_param.gridSize = $.jgrid.defaults.rowNum;
				$(OPER03010_GRID_ID).setGridParam({'postData': JSON.stringify(pageObj.itp_OPER03010_param)}).trigger('reloadGrid');
			});
		},
		clearData : function() {
			$(OPER03010_GRID_ID).jqGrid('clearGridData', true);
			$(OPER03010_GRID_LIST).find('.ui-jqgrid-bdiv').css('min-height', '100px');
			$(OPER03010_GRID_EMPTY).html(ITP_MSG_LOCALE.message.grid.noData);
			$(OPER03010_GRID_EMPTY).show();
		},
		unload : function() {
			$.jgrid.gridUnload(OPER03010_GRID_ID);
		}
	}
};

/*상세화면 Object*/
let viewObj = {
	init: function(param) {
		this.load(param);
	},
	load: function(param) {
		fn_ajax_call(AFFL_INFO_AFFL, param, this.callback, 'GET');
	},
	callback:  function(result) {
		console.log(result);
		pageObj.switchScreen('VIEW');
		$('#ITP_FORM_OPER03010_VIEW #ITP_FORM_OPER03010_VIEW_AFFL_SHOP_ID').val(result.afflShopId);

		$('#ITP_FORM_OPER03010_VIEW .fnAfflShopId').text(result.afflShopId);
		$('#ITP_FORM_OPER03010_VIEW .fnAfflShopNm').text(result.afflShopNm);
		$('#ITP_FORM_OPER03010_VIEW .fnStCd').text(result.stNm);
		$('#ITP_FORM_OPER03010_VIEW .fnCmpyTypeCd').text(result.corpType);
		$('#ITP_FORM_OPER03010_VIEW .fnBsnsRegNo').text(result.corpRegNo);
		$('#ITP_FORM_OPER03010_VIEW .fnCorpRegNo').text(result.corpRegNo);
		$('#ITP_FORM_OPER03010_VIEW .fnTelNo').text(result.ownerTelNo);
		$('#ITP_FORM_OPER03010_VIEW .fnFaxNo').text(result.rprstFaxNo);
		$('#ITP_FORM_OPER03010_VIEW .fnEmalAddr').text(result.rprstEmai);
		$('#ITP_FORM_OPER03010_VIEW .fnBsnsCndt').text(result.bsnsCndt);
		$('#ITP_FORM_OPER03010_VIEW .fnOwnerNm').text(result.ownerNm);
		$('#ITP_FORM_OPER03010_VIEW .fnCtgrBsns').text(result.ctgrBsns);
		$('#ITP_FORM_OPER03010_VIEW .fnOwnerTelNo').text(result.ownerTelNo);
		$('#ITP_FORM_OPER03010_VIEW .fnContSttDt').text(result.joinSttDt);
		$('#ITP_FORM_OPER03010_VIEW .fnContEndDt').text(result.joinEndDt);
		$('#ITP_FORM_OPER03010_VIEW .fnZipNo').text(result.zipNo);
		$('#ITP_FORM_OPER03010_VIEW .fnLoadAddr').text(result.addr1);
		$('#ITP_FORM_OPER03010_VIEW .fnDtlAddr').text(result.addr2);

		$('#ITP_FORM_OPER03010_VIEW .fnAddDt').text(result.regDt);
		$('#ITP_FORM_OPER03010_VIEW .fnChgDt').text(result.chgDt);

		kakaoMap.init('ITP_FORM_OPER03010_VIEW_MAP', result.cmpyAdres);

		// 영업담당자정보  리스트 조회
		viewObj.grid.load(result.saleList);
	},
	grid: {
		init: function() {
		},
		load: function(saleList) {
			// $(OPER03010_VIEW_GRID_ID).jqGrid({
			// 	colModel: gridColModel.detail,
			// 	data: saleList,
			// 	datatype: 'local',
			// 	pager: OPER03010_VIEW_GRID_PAGER,
			// 	rownumbers: true
			// }).navGrid(OPER03010_VIEW_GRID_PAGER, ITP_GRID_NAV_DEFAULTS.navGrid);

			var option = {
				gridId: OPER03010_VIEW_GRID_ID,
				colModel: gridColModel.detail,
				data: saleList,
				pager: OPER03010_VIEW_GRID_PAGER,
			};
			itp_fn_grid_make_local(option);
		},
		clearData : function() {
			$(OPER03010_VIEW_GRID_ID).jqGrid('clearGridData', true);
			$(OPER03010_VIEW_GRID_LIST).find('.ui-jqgrid-bdiv').css('min-height', '100px');
			$(OPER03010_VIEW_GRID_EMPTY).html(ITP_MSG_LOCALE.message.grid.noData);
			$(OPER03010_VIEW_GRID_EMPTY).show();
		},
		unload : function() {
			$.jgrid.gridUnload(OPER03010_VIEW_GRID_ID);
		}
	}
};

/*수정화면 Object*/
let modifyObj = {
	button: {
		modify: function () {
			itp_fn_form_clear_validate(null, '#ITP_FORM_OPER03010_DETAIL');
			const afflShopIdVal = $('#ITP_FORM_OPER03010_VIEW_AFFL_SHOP_ID').val();
			const key = {afflShopId: afflShopIdVal, viewCd: 'R'};
			var param = $.param(key);
			modifyObj.load(param);
		}
	},
	load: function(param) {
		fn_ajax_call(AFFL_INFO_AFFL, param, this.callback, 'GET');
	},
	callback: function(result) {
		console.log(result);
		pageObj.switchScreen('MODIFY');
		$('#ITP_FORM_OPER03010_DETAIL #ITP_FORM_OPER03010_DETAIL_VIEW_CD').val('U');

		$('#ITP_FORM_OPER03010_DETAIL #ITP_FORM_OPER03010_DETAIL_AFFL_SHOP_ID').val(result.afflShopId);
		$('#ITP_FORM_OPER03010_DETAIL .fnAfflShopId').text(result.afflShopId);
		$('#ITP_FORM_OPER03010_DETAIL .fnAfflShopNm').text(result.afflShopNm);
		$('#ITP_FORM_OPER03010_DETAIL #ITP_FORM_OPER03010_DETAIL_ST_CD').val(result.stNm);
		// $('#ITP_FORM_OPER03010_DETAIL #fnCmpyTypeCd').text(result.corpType);
		$('#ITP_FORM_OPER03010_DETAIL #ITP_FORM_OPER03010_DETAIL_BSNS_REG_NO').val(result.corpRegNo);
		$('#ITP_FORM_OPER03010_DETAIL #ITP_FORM_OPER03010_DETAIL_CORP_REG_NO').val(result.corpRegNo);
		$('#ITP_FORM_OPER03010_DETAIL #ITP_FORM_STINFO01010_DETAIL_TEL_NO').val(result.ownerTelNo);
		$('#ITP_FORM_OPER03010_DETAIL #ITP_FORM_STINFO01010_DETAIL_FAX_NO').val(result.rprstFaxNo);
		$('#ITP_FORM_OPER03010_DETAIL #ITP_FORM_OPER03010_DETAIL_EMAL_ADDR').val(result.rprstEmai);
		$('#ITP_FORM_OPER03010_DETAIL #ITP_FORM_OPER03010_DETAIL_BSNS_CNDT').val(result.bsnsCndt);
		$('#ITP_FORM_OPER03010_DETAIL #ITP_FORM_OPER03010_DETAIL_OWNER_NM').val(result.ownerNm);
		$('#ITP_FORM_OPER03010_DETAIL #ITP_FORM_OPER03010_DETAIL_CTGR_BSNS').val(result.ctgrBsns);
		$('#ITP_FORM_OPER03010_DETAIL #ITP_FORM_OPER03010_DETAIL_OWNER_TEL_NO').val(result.ownerTelNo);
		$('#ITP_FORM_OPER03010_DETAIL #ITP_FORM_OPER03010_SEARCH_CONT_STT_DT').val(result.joinSttDt);
		$('#ITP_FORM_OPER03010_DETAIL #ITP_FORM_OPER03010_SEARCH_CONT_END_DT').val(result.joinEndDt);
		$('#ITP_FORM_OPER03010_DETAIL #ITP_FORM_OPER03010_DETAIL_ZIPNO').val(result.zipNo);
		$('#ITP_FORM_OPER03010_DETAIL #ITP_FORM_OPER03010_DETAIL_LOAD_ADDR').val(result.addr1);
		$('#ITP_FORM_OPER03010_DETAIL #ITP_FORM_OPER03010_DETAIL_DTL_ADDR').val(result.addr2);

		$('#ITP_FORM_OPER03010_DETAIL .fnAddDt').text(result.regDt);
		$('#ITP_FORM_OPER03010_DETAIL .fnChgDt').text(result.chgDt);

		kakaoMap.init('ITP_FORM_OPER03010_DETAIL_MAP', $('#ITP_FORM_OPER03010_DETAIL_CMPY_ADRES').val());

		// 영업담당자 리스트 조회
		modifyObj.grid.load(result.saleList);
	},
	grid: {
		init: function() {
		},
		colModel: gridColModel.detail,
		load: function(gridData) {
			let param = $('#ITP_FORM_OPER03010_DETAIL').serializeObject();
			param.gridSize = $.jgrid.defaults.rowNum;
			param.pagingYn = false; // 페이지안함

			var option = {
				gridId: OPER03010_DETAIL_GRID_ID,
				colModel: gridColModel.detail,
				data: gridData,
				pager: OPER03010_DETAIL_GRID_PAGER,
			};
			itp_fn_grid_make_local(option);
		},
		clearData : function() {
			$(OPER03010_DETAIL_GRID_ID).jqGrid('clearGridData', true);
			$(OPER03010_DETAIL_GRID_LIST).find('.ui-jqgrid-bdiv').css('min-height', '100px');
			$(OPER03010_DETAIL_GRID_EMPTY).html(ITP_MSG_LOCALE.message.grid.noData);
			$(OPER03010_DETAIL_GRID_EMPTY).show();
		},
		unload : function() {
			$.jgrid.gridUnload(OPER03010_DETAIL_GRID_ID);
		}
	},
	map: function(locate) {
	}
};

/*신규등록 화면 Object*/
let createObj = {
	init: function() {
		this.load();
	},
	load: function() {
		kakaoMap.init('ITP_FORM_OPER03010_DETAIL_MAP', $('#ITP_FORM_OPER03010_DETAIL_STREET_ADDRESS').val());

		// 영업담당자 리스트 조회
		createObj.grid.load();
	},
	button: {
		duplicate: function() {
			const formId = '#ITP_FORM_OPER03010_DETAIL';
			itp_fn_form_clear_validate(null, formId + '_DETAIL');
			var vali_cmpyCd = itp_fn_form_validate(formId + '_DETAIL', formId + '_CMPY_CD', ['empty'], undefined);
			if (vali_cmpyCd) {
				var dupFn = function(result) {
					if (result.code == 'N') {
						ITP_FORM_OPER03010_DETAIL_IS_DUPLICATE = false;
					} else {
						ITP_FORM_OPER03010_DETAIL_IS_DUPLICATE = true;
					}
				};
				const key = {'cmpyCd':  $(formId + '_CMPY_CD').val()};
				const param = $.param(key);
				fn_ajax_call(COMPANY_CHECK_DUPLICATE, param, dupFn, 'GET');
			}
		},
		resetPass: function() {
			var resetPwFn = {
				callBack: function(args) {
					const key = {'userId':  $('#ITP_FORM_OPER03010_DETAIL_CMPY_CD').val()};
					const param = $.param(key);
					fn_ajax_call(USER_INTI_USERPW, param, undefined, 'GET');
				}
			};
			itp_fn_modal_confirm(ITP_MSG_LOCALE.message.ajax.askResetUserPw, resetPwFn, null);
		},
		resetGrid: function(e) {
			var gridId = OPER03010_DETAIL_GRID_ID.replace('#', '');
			var rids = $(OPER03010_DETAIL_GRID_ID).jqGrid('getDataIDs');
			var last_row_id = rids[rids.length - 1];
			itp_fn_grid_reset_selection(e, last_row_id, gridId, 'OPER03010_DETAIL');
		},
		address: function() {
			new daum.Postcode({
				oncomplete: function(data) {
					// 전체주소 리턴
					document.getElementById('ITP_FORM_OPER03010_DETAIL_CMPY_ZIPNO').value = data.zonecode;
					document.getElementById('ITP_FORM_OPER03010_DETAIL_CMPY_ADRES').value = data.roadAddress;
					document.getElementById('ITP_FORM_OPER03010_DETAIL_LOTS_ADDRESS').value = !!data.autoJibunAddress ? data.autoJibunAddress : data.jibunAddress;
					document.getElementById('ITP_FORM_OPER03010_DETAIL_STREET_ADDRESS').value = data.roadAddress;
					document.getElementById('ITP_FORM_OPER03010_DETAIL_HJ_DONG').value = !!data.hname ? data.hname : data.bname;
					document.getElementById('ITP_FORM_OPER03010_DETAIL_BJ_DONG').value = data.bname;

					kakaoMap.init('ITP_FORM_OPER03010_DETAIL_MAP', data.roadAddress);
					document.getElementById('ITP_FORM_OPER03010_DETAIL_CMPY_ADRES_DTL').focus();
				}
			}).open();
		},
		addRow: function() {
			// 팝업
			var popFn = function(rowDataPop) {
				// 기존등록 데이터
				var exists = '';
				const rowData = $(OPER03010_DETAIL_GRID_ID).getRowData();
				$.each(rowData, function(key, value) {
					exists = exists + value.saleMgrId + ';';
				});

				$.each(rowDataPop, function(key, value) {
					if(exists.indexOf(value.saleMgrId) < 0) {
						// 행추가
						$(OPER03010_DETAIL_GRID_ID).jqGrid('addRow', {position: 'last'});
						var rids = $(OPER03010_DETAIL_GRID_ID).jqGrid('getDataIDs');
						var last_row_id = rids[rids.length - 1];
						$(OPER03010_DETAIL_GRID_ID).jqGrid('setCell', last_row_id, 'viewCd', 'C');
						$(OPER03010_DETAIL_GRID_ID).jqGrid('setCell', last_row_id, 'saleMgrId', value.saleMgrId);
						$(OPER03010_DETAIL_GRID_ID).jqGrid('setCell', last_row_id, 'saleMgrNm', value.saleMgrNm);
						$(OPER03010_DETAIL_GRID_ID).jqGrid('setCell', last_row_id, 'stCd', value.stCd);
						$(OPER03010_DETAIL_GRID_ID).jqGrid('setCell', last_row_id, 'stNm', value.stNm);
					}
				});
				$(OPER03010_DETAIL_GRID_EMPTY).hide();
			};
			fn_call_popup('biz', 'BIZPOP_NK_SALES_USER_SCH', '#ITP_ASIDE', popFn, null, 'S');  //=====================================================================================
		},
		delRow: function() {
			itp_fn_grid_del_row(OPER03010_DETAIL_GRID_ID);
		},
		cancel: function() {
			listObj.grid.search();
		},
		save: function() {
			const formId = '#ITP_FORM_OPER03010_DETAIL';
			itp_fn_form_clear_validate(null, formId);
			var vali_cmpyCd = itp_fn_form_validate(formId, formId + '_CMPY_CD', ['empty'], undefined);
			var vali_cmpyStatCd = itp_fn_form_validate(formId, formId + '_CMPY_STAT_CD', ['empty'], undefined);
			var vali_cmpyTypeCd = itp_fn_form_validate(formId, formId + '_CMPY_TYPE_CD', ['empty'], undefined);
			var vali_cmpyNm = itp_fn_form_validate(formId, formId + '_CMPY_NM', ['empty'], undefined);
			var vali_bossNm = itp_fn_form_validate(formId, formId + '_BOSS_NM', ['empty'], undefined);
			var vali_mainTel = itp_fn_form_validate(formId, formId + '_MAIN_TEL', ['empty'], undefined);
			var vali_mainEmail = itp_fn_form_validate(formId, formId + 'MAIN_EMAIL', ['empty'], undefined);

			if (vali_cmpyCd && vali_cmpyStatCd && vali_cmpyTypeCd && vali_cmpyNm && vali_bossNm && vali_mainTel && vali_mainEmail) {

				if($('#ITP_FORM_OPER03010_DETAIL_CMPY_ZIPNO').val() == '' || $('#ITP_FORM_OPER03010_DETAIL_CMPY_ADRES').val() == '') {
					itp_fn_modal_alert('주소 검색을 통해 회사 주소를 입력하세요.');
					return;
				}

				if (ITP_FORM_OPER03010_DETAIL_IS_DUPLICATE) {
					itp_fn_modal_duplicate('회사코드 중복체크를 해주세요.', formId + '_CMPY_CD');
				} else {
					let gridInsertData = [];
					let gridUpdateData = [];
					let gridDeleteData = [];
					const rowData = $(OPER03010_DETAIL_GRID_ID).getRowData();
					const keyValue = $(formId + '_CMPY_CD').val();
					$.each(rowData, function(key, value) {
						if (value.viewCd != 'R') {
							value.userId = keyValue;
							if (value.viewCd == 'C') {
								gridInsertData.push(value);
							} else if (value.viewCd == 'U') {
								gridUpdateData.push(value);
							} else if (value.viewCd == 'D') {
								gridDeleteData.push(value);
							}
						}
					});

					let param = $(formId).serializeObject();
					param.gridInsertData = gridInsertData;
					param.gridUpdateData = gridUpdateData;
					param.gridDeleteData = gridDeleteData;
					var searhFn = function() {
						ITP_FORM_OPER03010_DETAIL_IS_WRITING = false;
						listObj.grid.search();
					};
					fn_ajax_call(COMPANY_SAVE_COMPANY, JSON.stringify(param), searhFn, 'POST');
				}
			}
		}
	},
	grid: {
		init: function () {
			this.unload();
			this.load();
		},
		colModel: gridColModel.detail,
		load: function () {
			let param = $('#ITP_FORM_OPER03010_DETAIL').serializeObject();
			param.gridSize = $.jgrid.defaults.rowNum;
			param.pagingYn = false; // 페이지안함

			var option = {
				gridId: OPER03010_DETAIL_GRID_ID,
				colModel: gridColModel.detail,
				param: JSON.stringify(param),
				url: DOMAIN + AFFL_DETAIL_GRID_LIST,
				pager: OPER03010_DETAIL_GRID_PAGER,
				loadComplete: function(data) {
					itp_fn_grid_load_complete(data, OPER03010_DETAIL_GRID_ID, true, undefined, 'OPER03010_DETAIL');
				},
				onPaging: function(action) {
					var pagingFn = {
						callBack: function(args) {
							$(args).trigger('reloadGrid');
						}
					};
					if (itp_fn_check_grid_is_writing(OPER03010_DETAIL_GRID_ID)) {
						itp_fn_modal_confirm(ITP_MSG_LOCALE.message.ajax.cancelData, pagingFn, OPER03010_DETAIL_GRID_ID);
						return 'stop';
					} else {
						itp_fn_grid_paging(OPER03010_DETAIL_GRID_ID, action, param);
					}
				},
				onSortCol: function(index, columnIndex, sortOrder) {
					var sortingFn = {
						callBack: function(args) {
							$(args).trigger('reloadGrid');
						}
					};
					if (itp_fn_check_grid_is_writing(OPER03010_DETAIL_GRID_ID)) {
						itp_fn_modal_confirm(ITP_MSG_LOCALE.message.ajax.cancelData, sortingFn, OPER03010_DETAIL_GRID_ID);
						return 'stop';
					} else {
						itp_fn_grid_sorting(OPER03010_DETAIL_GRID_ID, index, sortOrder);
					}
				}
			};
			itp_fn_grid_make_remote(option);
		},
		clearData : function() {
			$(OPER03010_DETAIL_GRID_ID).jqGrid('clearGridData', true);
			$(OPER03010_DETAIL_GRID_LIST).find('.ui-jqgrid-bdiv').css('min-height', '100px');
			$(OPER03010_DETAIL_GRID_EMPTY).html(ITP_MSG_LOCALE.message.grid.noData);
			$(OPER03010_DETAIL_GRID_EMPTY).show();
		},
		unload : function() {
			$.jgrid.gridUnload(OPER03010_DETAIL_GRID_ID);
		}
	}
};
