require(['config'], function() {
	require([
		'jquery.bootstrap.fileUpload' //파일 업로드가 있는 페이지에서 로딩
	], function($) {
		pageObj.init();
	});
});

/********************************************************
 --------------------------------------------------------
 - Object 목록								            -
 --------------------------------------------------------
 * const gridColModel = {}	: 화면 Grid Object			*
 * let pageObj = {}			: 화면공통 Object			*
 * let listObj = {}			: 목록화면 Object			*
 * let viewObj = {}			: 상세화면 Object			*
 * let modifyObj = {}		: 수정화면 Object			*
 * let createObj = {}		: 신규화면 Object			*
 *******************************************************/

/*화면 변수*/
const STINFO07010_GRID_ID = '#ITP_STINFO07010_jqGrid';
const STINFO07010_GRID_LIST = '#ITP_STINFO07010_jqGrid_list';
const STINFO07010_GRID_PAGER = '#ITP_STINFO07010_jqGridPager';
const STINFO07010_GRID_EMPTY = '#ITP_STINFO07010_jqGridEmpty';

let ITP_FORM_STINFO07010_DETAIL_IS_DUPLICATE = false;
let ITP_FORM_STINFO07010_DETAIL_IS_WRITING = false;

/*API URL*/
let API_DETAIL_GRID_LIST 	= '/api/item/itemclass-grid-list';	    // 목록
let API_DETAIL_INFO 		= '/api/item/info-itemClassMng';		// 상세
let API_DETAIL_SAVE 		= '/api/item/save-itemClassMng';		// 저장
let API_DETAIL_DELETE 		= '/api/item/del-itemClassMng';			// 삭제
let API_ITEM_CLASS_LEVEL	= '/api/item/class-level-list';			//품목분류 level 검색

/*화면 Grid ColModel*/
const gridColModel = {
	list: [
		{
			index: 'BRAND_ID', name: 'brandId',
			label: ITP_MSG_LOCALE.label.brandId, //브랜드ID
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: true
		},
		{
			index: 'ITEM_CLASS_MNG_NO', name: 'itemClassMgntNo',
			label: ITP_MSG_LOCALE.label.itemClassMgntNo, //품목분류명
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: true
		},
		{
			index: 'ITEM_CLASS_NM', name: 'itemClassNm',
			label: ITP_MSG_LOCALE.label.itemClassNm, //품목분류명
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'ITEM_CLASS_LEVEL1', name: 'itemClass1',
			label: ITP_MSG_LOCALE.label.itemClassLevel1, //품목분류Level 1
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'ITEM_CLASS_LEVEL2', name: 'itemClass2',
			label: ITP_MSG_LOCALE.label.itemClassLevel2, //품목분류Level 2
			width: '13', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'ITEM_CLASS_LEVEL3', name: 'itemClass3',
			label: ITP_MSG_LOCALE.label.itemClassLevel3, //품목분류Level 3
			width: '13', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'ITEM_CLASS_LEVEL4', name: 'itemClass4',
			label: ITP_MSG_LOCALE.label.itemClassLevel4, //품목분류Level 4
			width: '6', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'PRN_SEQ', name: 'prnSeq',
			label: ITP_MSG_LOCALE.label.prnSeq, //출력순번
			width: '15', fixed: false, align: 'center',
			sortable: false, hidden: false
		}
	]
};

/*화면공통 Object*/
let pageObj = {
	init: function () {
		this.brandInfo = JSON.parse(sessionStorage.getItem('itp_manage_brand_info'));
		this.ui.init();
		this.event.init();
	},
	brandInfo: {},
	ui: {
		init: function () {
			this.view();
			this.grid();
			this.ready();
		},
		view: function() {
			// 버튼 권한설정
			fn_proc_btn_auth('STINFO07010');

			// 공통코드 표시
			itemClassLevel.list(1, true);
		},
		grid: function() {
			itp_fn_jqgrid_resize(STINFO07010_GRID_ID, STINFO07010_GRID_LIST, 'lg');
			listObj.empty.init();
			itp_fn_fire_window_resize();
		},
		ready: function() {
			listObj.init();
		}
	},
	event: {
		init: function () {
			this.button();
		},
		button: function () {
			// 버튼 클릭 이벤트
			$('button').each(function() {
				var id = $(this).attr('id');
				$(this).on('click', function() {
					switch (id) {
						case 'ITP_BTN_STINFO07010_SRH'				: listObj.button.search();		break;	// 조회 버튼 클릭
						case 'ITP_BTN_STINFO07010_NEWREG'			: listObj.popup(); 				break;	// 신규등록 버튼
						case 'ITP_BTN_STINFO07010_MODIFY'			: modifyObj.button.modify();	break;	// 수정 버튼
						case 'ITP_BTN_STINFO07010_CANCELLIST'		: createObj.button.cancel(); 	break;	// 취소/목록 버튼
						case 'ITP_BTN_STINFO07010_DELETE'			: 								break;	// 삭제 버튼
						case 'ITP_BTN_STINFO07010_SAVE'				: createObj.button.save(); 		break;	// 저장 버튼
						case 'ITP_FORM_STINFO07010_DETAIL_DUP'		: createObj.button.duplicate();	break;	// 중복체크
						case 'ITP_BTN_STINFO07010_RESET_PW'			: createObj.button.resetPass();	break;	// 상세:비밀번호 초기화
					}
				});
			});

		}
	},
	switchScreen: function(mode) {
		if(mode == 'LIST') { // 목록
			$('#ITP_BTN_STINFO07010_MODIFY').hide();
			$('#ITP_BTN_STINFO07010_CANCELLIST').hide();
			$('#ITP_BTN_STINFO07010_DELETE').hide();
			$('#ITP_BTN_STINFO07010_SAVE').hide();
			fn_show_btn_auth('#ITP_BTN_STINFO07010_SRH');
			fn_show_btn_auth('#ITP_BTN_STINFO07010_NEWREG');

			$('#ITP_AJAX_STINFO07010_LIST_CONTAINER').show();
			$('#ITP_AJAX_STINFO07010_DETAIL_CONTAINER').hide();
			$('#ITP_AJAX_STINFO07010_VIEW_CONTAINER').hide();
		} else if(mode == 'ADD') { // 등록
			$('#ITP_BTN_STINFO07010_SRH').hide();
			$('#ITP_BTN_STINFO07010_MODIFY').hide();
			$('#ITP_BTN_STINFO07010_NEWREG').hide();
			$('#ITP_BTN_STINFO07010_DELETE').hide();
			$('#ITP_BTN_STINFO07010_RESET_PW').hide();
			fn_show_btn_auth('#ITP_BTN_STINFO07010_CANCELLIST');
			fn_show_btn_auth('#ITP_BTN_STINFO07010_SAVE');

			$('#ITP_AJAX_STINFO07010_LIST_CONTAINER').hide();
			$('#ITP_AJAX_STINFO07010_DETAIL_CONTAINER').show();
			$('#ITP_AJAX_STINFO07010_VIEW_CONTAINER').hide();
			$('#ITP_FORM_STINFO07010_DETAIL_STORE_ID').removeAttr('readonly');
			$('#ITP_FORM_STINFO07010_DETAIL_DUP').removeAttr('disabled');

			$.each($('input, select, checkbox, radio, textarea', '#ITP_FORM_STINFO07010_DETAIL'),function(k) {
				$(this).val('');
			});

			$('#ITP_FORM_STINFO07010_DETAIL_VIEW_CD').val('C');
			$('#ITP_FORM_STINFO07010_DETAIL .fnStoreNm').text('(자동부여)');
		} else if(mode == 'MODIFY') { // 수정
			$('#ITP_BTN_STINFO07010_SRH').hide();
			$('#ITP_BTN_STINFO07010_MODIFY').hide();
			$('#ITP_BTN_STINFO07010_NEWREG').hide();
			$('#ITP_BTN_STINFO07010_DELETE').hide();
			fn_show_btn_auth('#ITP_BTN_STINFO07010_CANCELLIST');
			fn_show_btn_auth('#ITP_BTN_STINFO07010_SAVE');
			fn_show_btn_auth('#ITP_BTN_STINFO07010_RESET_PW');

			$('#ITP_AJAX_STINFO07010_LIST_CONTAINER').hide();
			$('#ITP_AJAX_STINFO07010_DETAIL_CONTAINER').show();
			$('#ITP_AJAX_STINFO07010_VIEW_CONTAINER').hide();
			$('#ITP_FORM_STINFO07010_DETAIL_STORE_ID').attr('readonly', true);
			$('#ITP_FORM_STINFO07010_DETAIL_DUP').attr('disabled', true);
			$('#ITP_FORM_STINFO07010_DETAIL_SEARCH_AFFL_SHOP_NM').attr('readonly', true);

			$('#ITP_FORM_STINFO07010_DETAIL_SEARCH_AFFL_SHOP').hide();
			$('#ITP_FORM_STINFO07010_DETAIL_DELETE_AFFL_SHOP').hide();
		} else if(mode == 'VIEW') { // 보기
			$('#ITP_BTN_STINFO07010_SRH').hide();
			$('#ITP_BTN_STINFO07010_NEWREG').hide();
			$('#ITP_BTN_STINFO07010_DELETE').hide();
			$('#ITP_BTN_STINFO07010_SAVE').hide();
			fn_show_btn_auth('#ITP_BTN_STINFO07010_MODIFY');
			fn_show_btn_auth('#ITP_BTN_STINFO07010_CANCELLIST');

			$('#ITP_AJAX_STINFO07010_LIST_CONTAINER').hide();
			$('#ITP_AJAX_STINFO07010_DETAIL_CONTAINER').hide();
			$('#ITP_AJAX_STINFO07010_VIEW_CONTAINER').show();
		}
	}
};

/*목록화면 Object*/
let listObj = {
	init: function () {
		this.form();
		this.grid.init();
	},
	itp_STINFO07010_search: false,
	button: {
		search: function() {
			listObj.itp_STINFO07010_search = true;
			let param = $('#ITP_FORM_STINFO07010_SEARCH').serializeObject();
			param.gridSize = $.jgrid.defaults.rowNum;
			param.gridPage = $.jgrid.defaults.page;
			$(STINFO07010_GRID_ID).setGridParam({'postData': JSON.stringify(param)}).trigger('reloadGrid');
		},
		create: function() {
			if(pageObj.brandInfo && pageObj.brandInfo.brandId !== '') {
				createObj.init();
			}
		}
	},
	form: function() {
		$('#ITP_FORM_STINFO07010_SEARCH_ITEM_CLASS1').on('change', function() {
			($(this).val() === '') ? itemClassLevel.clear(2, true): itemClassLevel.list(2, true);
		});
		$('#ITP_FORM_STINFO07010_SEARCH_ITEM_CLASS2').on('change', function() {
			($(this).val() === '') ? itemClassLevel.clear(3, true): itemClassLevel.list(3, true);
		});
		$('#ITP_FORM_STINFO07010_SEARCH_ITEM_CLASS3').on('change', function() {
			($(this).val() === '') ? itemClassLevel.clear(4, true): itemClassLevel.list(4, true);
		});
	},
	empty: {
		init: function() {
			var _this = this;
			this.push();
			$(STINFO07010_GRID_EMPTY).on('click', function() {
				_this.back();
				_this.itp_STINFO07010_param.gridSize = $.jgrid.defaults.rowNum;
				$(STINFO07010_GRID_ID).setGridParam({'postData': JSON.stringify(_this.itp_STINFO07010_param)}).trigger('reloadGrid');
			});
		},
		itp_STINFO07010_param: {},
		push: function() {
			let param = $('#ITP_FORM_STINFO07010_SEARCH').serializeObject();
			listObj.itp_STINFO07010_param = param;
		},
		back: function() {
			$('#ITP_FORM_STINFO07010_SEARCH_ITEM_CLASS1').val(this.itp_STINFO07010_param.sitemClass1);
			$('#ITP_FORM_STINFO07010_SEARCH_ITEM_CLASS2').val(this.itp_STINFO07010_param.sitemClass2);
			$('#ITP_FORM_STINFO07010_SEARCH_ITEM_CLASS3').val(this.itp_STINFO07010_param.sitemClass3);
			$('#ITP_FORM_STINFO07010_SEARCH_ITEM_CLASS4').val(this.itp_STINFO07010_param.sitemClass4);
			$('#ITP_FORM_STINFO07010_SEARCH_ITEM_NM').val(this.itp_STINFO07010_param.sitemNm);
		}
	},
	grid: {
		init: function () {
			// 데이터 없을때
			listObj.empty.push();
			this.search();
		},
		search: function() {
			pageObj.switchScreen('LIST');
			this.unload();
			this.load();
		},
		load: function() {
			let param = $('#ITP_FORM_STINFO07010_SEARCH').serializeObject();
			param.gridSize = $.jgrid.defaults.rowNum;
			param.sbrandId = pageObj.brandInfo.brandId;

			var option = {
				gridId: STINFO07010_GRID_ID,
				colModel: gridColModel.list,
				param: JSON.stringify(param),
				url: DOMAIN + API_DETAIL_GRID_LIST,
				pager: STINFO07010_GRID_PAGER,
				multiselect: true,
				onCellSelect: function(rowId, cellIdx, cellValue) {
					var cm = $(this).jqGrid('getGridParam', 'colModel');
					var colNm = cm[cellIdx].name;
					if (colNm == 'itemClassNm') {
						const selectVal = $(this).jqGrid('getCell', rowId, 'itemClassMgntNo');
						const key = {brandId:pageObj.brandInfo.brandId, itemClassMgntNo: selectVal, viewCd: 'R'};
						var param = $.param(key);
						viewObj.init(param);
					}
				},
				loadComplete: function(data) {
					console.log(data);
					// itp_fn_grid_load_complete(data, STINFO07010_GRID_ID, true, '', 'STINFO07010', listObj.itp_STINFO07010_search, listObj.empty, true, data.gridRecords, true);
					itp_fn_grid_load_complete(data, STINFO07010_GRID_ID, true, undefined, 'STINFO07010', listObj.itp_STINFO07010_search, listObj.empty, true, data.gridRecords, false);
					var ids = $(STINFO07010_GRID_ID).getDataIDs();
					$.each(ids, function(idx, rowId) {
						$(STINFO07010_GRID_ID).jqGrid('setCell', rowId, 'itemClassNm', '', ITP_GRID_COL_STYLE.link);
					});
				},
				onPaging: function(action) {
					itp_fn_grid_paging(STINFO07010_GRID_ID, action, param);
				}
			};
			itp_fn_grid_make_remote(option);
		},
		clearData : function() {
			$(STINFO07010_GRID_ID).jqGrid('clearGridData', true);
			$(STINFO07010_GRID_LIST).find('.ui-jqgrid-bdiv').css('min-height', '100px');
			$(STINFO07010_GRID_EMPTY).html(ITP_MSG_LOCALE.message.grid.noData);
			$(STINFO07010_GRID_EMPTY).show();
		},
		unload : function() {
			$.jgrid.gridUnload(STINFO07010_GRID_ID);
		}
	},
	popup: function(param) {
		// 팝업
		var popFn = function(rowDataPop) {
			console.log(rowDataPop);
		};
		fn_call_popup('biz', 'BIZPOP_ITEM_CLASS_MANAGE', '#ITP_ASIDE', popFn, param, 'S');
	}
};

/*수정화면 Object*/
let modifyObj = {
	init: function () {
	},
	button: {
		modify: function (param) {
			itp_fn_form_clear_validate(null, '#ITP_FORM_STINFO07010_DETAIL');
			const selectVal = $('#ITP_FORM_STINFO07010_VIEW_BRAND_UNIT_UNQ_NO').val();
			const key = {brandId:pageObj.brandInfo.brandId, brandUnitUnqNo: selectVal, viewCd: 'R'};
			var param = $.param(key);
			modifyObj.load(param);
		}
	},
	load: function(param) {
		fn_ajax_call(API_DETAIL_INFO, param, this.callback, 'GET');
	},
	callback: function (result) {
		console.log(result);
		pageObj.switchScreen('MODIFY');

		$('#ITP_FORM_STINFO07010_DETAIL #ITP_FORM_STINFO07010_DETAIL_VIEW_CD').val('U');
		$('#ITP_FORM_STINFO07010_DETAIL #ITP_FORM_STINFO07010_DETAIL_ITEM_ID').val(result.itemId);
		$('#ITP_FORM_STINFO07010_DETAIL #ITP_FORM_STINFO07010_DETAIL_BRAND_UNIT_UNQ_NO').val(result.brandUnitUnqNo);
		$('#ITP_FORM_STINFO07010_DETAIL .fnBrandNm').text(result.brandId);
		$('#ITP_FORM_STINFO07010_DETAIL #ITP_FORM_STINFO07010_DETAIL_ST_CD').val(result.unitStCd);
		// $('#ITP_FORM_STINFO07010_DETAIL .fnItemClassMgntNo').text(result.itemId);
		$('#ITP_FORM_STINFO07010_DETAIL #ITP_FORM_STINFO07010_DETAIL_ITEM_CLASS_MGNT_NO').val(result.itemClassMgntNo);
		$('#ITP_FORM_STINFO07010_DETAIL #ITP_FORM_STINFO07010_DETAIL_ITEM_NM').val(result.itemClassNm);
		$('#ITP_FORM_STINFO07010_DETAIL #ITP_FORM_STINFO07010_DETAIL_SPPLY_ID').val(result.spplyId);
		$('#ITP_FORM_STINFO07010_DETAIL #ITP_FORM_STINFO07010_DETAIL_SPPLY_NM').val(result.spplyNm);
		$('#ITP_FORM_STINFO07010_DETAIL #ITP_FORM_STINFO07010_DETAIL_SPPLY_ITEM_ID').val(result.spplyItemId);
		$('#ITP_FORM_STINFO07010_DETAIL #ITP_FORM_STINFO07010_DETAIL_CONT_STT_DT').val(result.contSttDt);
		$('#ITP_FORM_STINFO07010_DETAIL #ITP_FORM_STINFO07010_DETAIL_CONT_END_DT').val(result.contEndDt);
		$('#ITP_FORM_STINFO07010_DETAIL #ITP_FORM_STINFO07010_DETAIL_LEAD_TIME').val(result.leadTime);
		$('#ITP_FORM_STINFO07010_DETAIL #ITP_FORM_STINFO07010_DETAIL_UNIT').val(result.unit);
		$('#ITP_FORM_STINFO07010_DETAIL #ITP_FORM_STINFO07010_DETAIL_STDD_QYT').val(result.stddQty);
		$('#ITP_FORM_STINFO07010_DETAIL #ITP_FORM_STINFO07010_DETAIL_CURR').val(result.curr);
		$('#ITP_FORM_STINFO07010_DETAIL #ITP_FORM_STINFO07010_DETAIL_UNIT_AMT').val(result.unitAmt);
		$('#ITP_FORM_STINFO07010_DETAIL #ITP_FORM_STINFO07010_DETAIL_STORE_SALE_STDD_QTY').val(result.storeSaleStddQty);
		$('#ITP_FORM_STINFO07010_DETAIL #ITP_FORM_STINFO07010_DETAIL_STORE_SALE_UNIT_AMT').val(result.storeSaleUnitAmt);
		$('#ITP_FORM_STINFO07010_DETAIL .fnRegId').text(result.regId);
		$('#ITP_FORM_STINFO07010_DETAIL .fnRegDt').text(result.regDt);
		$('#ITP_FORM_STINFO07010_DETAIL .fnChgId').text(result.chgId);
		$('#ITP_FORM_STINFO07010_DETAIL .fnChgDt').text(result.chgDt);
		$.each(result.imageFileNoList, function(index, item) {
			$('#ITP_FORM_STINFO07010_VIEW .ITEM_IMAGE').append('<img src=" + item.filePath +" />');
		});
	}
};

/*신규화면 Object*/
let createObj = {
	init: function () {
		pageObj.switchScreen('ADD');
		itp_fn_form_clear_validate(null, '#ITP_FORM_STINFO07010_DETAIL');
		$('#ITP_FORM_STINFO07010_DETAIL_BRAND_ID').val(pageObj.brandInfo.brandId);
	},
	button: {
		cancel: function() {
			listObj.grid.search();
		},
		save: function() {
			const formId = '#ITP_FORM_STINFO07010_DETAIL';
			itp_fn_form_clear_validate(null, formId);
			var vali_userId = itp_fn_form_validate(formId, formId + '_USER_ID', ['empty'], undefined);
			var vali_userStatCd = itp_fn_form_validate(formId, formId + '_USER_STAT_CD', ['empty'], undefined);
			var vali_userNm = itp_fn_form_validate(formId, formId + '_USER_NM', ['empty'], undefined);
			var vali_telNo = itp_fn_form_validate(formId, formId + '_TEL_NO', ['empty'], undefined);
			var vali_email = itp_fn_form_validate(formId, formId + '_EMAIL', ['empty'], undefined);
			var vali_userPw = true;
			var vali_userPwConfirm = true;
			if (vali_userId && vali_userStatCd && vali_userNm && vali_userPw && vali_userPwConfirm && vali_telNo && vali_email) {
				if (ITP_FORM_STINFO07010_DETAIL_IS_DUPLICATE) {
					itp_fn_modal_duplicate(ITP_MSG_LOCALE.label.userId, formId + '_USER_ID');
				} else {
					let param = $(formId).serializeObject();
					//console.log(JSON.stringify(param));
					var searhFn = function() {
						ITP_FORM_STINFO07010_DETAIL_IS_WRITING = false;
						listObj.grid.search();
					};
					fn_ajax_call(API_DETAIL_SAVE, JSON.stringify(param), searhFn, 'POST');
				}
			}
		}
	}
};

var itemClassLevel = {
	level: 1,
	keys: function() {
		var keys = {sBrandId:pageObj.brandInfo.brandId, sItemLevel: this.level};
		for(var i=1; i<this.level; i++) {
			var key = 'sItemClass' + i;
			var id = '#ITP_FORM_STINFO07010_SEARCH_ITEM_CLASS' + i;
			keys[key] = $(id + ' option:selected').val();
		}
		return keys;
	},
	list: function(level) {
		this.level = level;
		this.clear(level);
		this.call( $.param(this.keys()));
	},
	call: function(param) {
		fn_ajax_call(API_ITEM_CLASS_LEVEL, param, this.callback, 'GET');
	},
	callback: function(result) {
		// console.log(result);
		var id ='ITP_FORM_STINFO07010_SEARCH_ITEM_CLASS' + itemClassLevel.level;
		fn_make_select_item_class(result.searchList, id, true, '선택');
	},
	clear: function(level, isList) {
		for(var i=level; i<5; i++) {
			var id = 'ITP_FORM_STINFO07010_SEARCH_ITEM_CLASS' + i;
			$('#' + id).find('option').remove();
		}
	}
};
